## wws 1.4.5

=== Makefile ===
#
# top level makefile for the W Window System
#
# CHANGES
# ++eero 3/1998:
# - moved configuration variables into configs/ subdirectory.
# ++eero 4/2004:
# - added SDL option
# - wt is now part of basic W packages
# ++eero 7/2008
# - more info at install what else needs to be done
# ++eero 8/2009
# - Moved *DIR variables setting for .config file here from configs/* files
# - Added scripts, icons and documentation installation
# - support for separate installation and run paths

WMAJ = 1
WMIN = 4
WPL  = 5

NAME = w$(WMAJ)r$(WMIN)pl$(WPL)
CONFIG = .config
COPY = cp

ifeq ($(CONFIG),$(wildcard $(CONFIG)))
include $(CONFIG)
else
help:
	@echo "First you have to 'make config'!"
	@echo
	@echo "Makefile recognizes automatically some OSes and tries to"
	@echo "configure the build system accordingly.  If this fails or"
	@echo "you want to configure W window system e.g. for a certain"
	@echo "gfx system, there are some special targets. Just check the"
	@echo "main Makefile or look into configs/ subdirectory for examples."
	@false
endif


basic:
	@date > .started
	@echo ; $(MAKE) -C lib
	@echo ; $(MAKE) -C server
	@echo ; $(MAKE) -C apps
	@echo ; $(MAKE) -C games
	@echo ; $(MAKE) -C benchmark
	@echo ; $(MAKE) -C wt

all: $(CONFIG) basic
	@echo
	@echo "make started/finished at:"
	@cat .started ; rm -f .started ; date
	@echo ""

full: $(CONFIG) basic
	@echo ; $(MAKE) -C fonts
	@echo ; $(MAKE) -C demos
	@echo ; $(MAKE) -C w2xlib
	@echo ; $(MAKE) -C wlua
	@echo
	@echo "make started/finished at:"
	@cat .started ; rm -f .started ; date
	@echo ""


installbasic:
	@echo ; $(MAKE) -C lib install
	@echo ; $(MAKE) -C server install
	@echo ; $(MAKE) -C apps install
	@echo ; $(MAKE) -C games install
	@echo ; $(MAKE) -C benchmark install
	@echo ; $(MAKE) -C wt install
	@echo ; $(MAKE) -C fonts install
	@echo ; $(MAKE) -C man install
	@echo ; $(MAKE) -C scripts install
	@echo ; $(MAKE) -C docs install
ifdef DATADIR
	$(INSTALL) -m 644 wconfig $(DATADIR)
	$(INSTALL) -m 755 wrc $(DATADIR)
endif


install: installbasic
	@echo ""
	@echo "W Window System installed, what next?"
	@echo "-------------------------------------"
	@echo ""
	@echo "You may need to run 'ldconfig $(LIBDIR)' (as root) for W shared"
	@echo "libraries to get loaded when W server and clients are started."
	@echo ""
	@echo "And to get terminal programs working, 'tic wterm.terminfo'."
	@echo ""
	@echo "Then you could copy 'wconfig' and 'wrc' to your home directory"
	@echo "as '.wconfig' and '.wrc' and edit them to customize server root"
	@echo "menu, fonts and colors to your preferences and to automatically"
	@echo "run programs when the server starts up."
	@echo ""
	@echo "W window system can be started with the 'startw' script."
	@echo "Some useful scripts are in scripts/ -subdirectory."
	@echo ""

installfull: installbasic
	@echo ; $(MAKE) -C demos install
	@echo ; $(MAKE) -C w2xlib install
	@echo ; $(MAKE) -C wlua install


# Some systems (SVGALIB) need wserver to be suid root to access graphics.
# WTerm would also need to be suid to be able to write into 'utmp'
# file, but as that's not necessary it won't be done by default. Less
# there are possible security holes, the better.
set-rights:
	chown 0.0 $(BINDIR)/wserver
	chmod u+s $(BINDIR)/wserver
	@echo "wserver is now suid root!"


clean:
	@echo ; $(MAKE) -C lib clean
	@echo ; $(MAKE) -C server clean
	@echo ; $(MAKE) -C apps clean
	@echo ; $(MAKE) -C games clean
	@echo ; $(MAKE) -C benchmark clean
	@echo ; $(MAKE) -C wt clean
	@echo ; $(MAKE) -C fonts clean
	@echo ; $(MAKE) -C man clean
	@$(RM) .started

cleanfull: clean
	@echo ; $(MAKE) -C demos clean
	@echo ; $(MAKE) -C w2xlib clean
	@echo ; $(MAKE) -C wlua clean

verycleanbasic:
	@echo ; $(MAKE) -C lib veryclean
	@echo ; $(MAKE) -C server veryclean
	@echo ; $(MAKE) -C apps veryclean
	@echo ; $(MAKE) -C games veryclean
	@echo ; $(MAKE) -C benchmark veryclean
	@echo ; $(MAKE) -C wt veryclean
	@echo ; $(MAKE) -C fonts veryclean
	@echo ; $(MAKE) -C man veryclean
	@echo ; $(MAKE) -C man/cat1 veryclean

veryclean: verycleanbasic
	@$(RM) .started $(CONFIG)

verycleanfull: verycleanbasic
	@echo ; $(MAKE) -C demos veryclean
	@echo ; $(MAKE) -C w2xlib veryclean
	@echo ; $(MAKE) -C wlua veryclean
	@$(RM) .started $(CONFIG)


ifeq ($(CONFIG),$(wildcard $(CONFIG)))
package: verycleanfull
	tar -zcvf ../$(NAME).tgz --exclude CVS -C ../ wws/
else
package: config verycleanfull
	tar -zcvf ../$(NAME).tgz --exclude CVS -C ../ wws/
endif


#
# some rules to configurate to your setup. it uses 'uname' to
# determine your OS and copy platform dependent defines from
# configs/ directory to '.config' which will be included by subsequent
# makefiles. if you port W to a new platform you must add a new
# section here and corresponding settings file into configs/.
#

# MiNT's "uname" seems to always print a \n even with -n
ARCH = $(shell echo -n `uname -s`)

# for linux get also the machine type (Motorola, Intel, Sparc, Alpha...)
ifeq ($(ARCH),Linux)
ARCH = $(shell uname -s)-$(shell uname -m)
endif


# default configs should always build all the graphics drivers given platform
# supports.  We want to see whether they (still) compile, won't we?
#
# We'll need to check the whole uname output here as the same OS might work
# on platforms requiring different options (libraries, graphics drivers).

Linux-m68k:
	$(COPY) configs/$@ $(CONFIG)

Linux-arm Linux-x86 Linux-i486 Linux-i586 Linux-i686: linuxsdl-config

Linux-mips-r3912: linuxr3912-config messages

linuxr3912-config:
	$(COPY) configs/Linux-mips-r3912 $(CONFIG)

OSF1:
	$(COPY) configs/$@ $(CONFIG)
	@echo
	@echo "***WARNING***  This entry is /intended/ for testing whether W (clients)"
	@echo "can work with 64-bit ints, but the testing/fixing hasn't been done yet."

MiNT:
	$(COPY) configs/$@ $(CONFIG)

NetBSD:
	$(COPY) configs/$@ $(CONFIG)

#
# Sparc2/SunOS-4: sun4c
# Sparc5/Solaris-2.4: sun4m
# Ultra1/Solaris-2.5.1: sun4u
#
# only works on sun4c so far, so no further discrimination
#

SunOS:
	$(COPY) configs/$@ $(CONFIG)


#
# now here are the real rules
#

$(CONFIG):
	@echo
	@echo "You need to 'make config' first before doing the real compile!"
	@echo
	@echo "Alternative configurations are svgalib-config, linuxfb-config,"
	@echo "linuxggi-config and linuxsdl-config which configure W against"
	@echo "different graphics and input backends."
	@echo
	@false


# If any of these differ on your machine, send us mail and we'll move
# that setting to files in configs/!

# overridable installation directory prefix for Debian
ifdef DESTDIR
PREFIX := /usr
else
# overridable installation directory prefix for direct compilation
PREFIX ?= /usr/local
endif

pathversion:
	@echo "" >> $(CONFIG)
	@echo "# version" >> $(CONFIG)
	@echo "WMAJ = " $(WMAJ) >> $(CONFIG)
	@echo "WMIN = " $(WMIN) >> $(CONFIG)
	@echo "WPL  = " $(WPL)  >> $(CONFIG)
	@echo "" >> $(CONFIG)
	@echo "# installation directories" >> $(CONFIG)
	@echo "DOCDIR	= " $(DESTDIR)$(PREFIX)/share/doc/wws >> $(CONFIG)
	@echo "MANDIR	= " $(DESTDIR)$(PREFIX)/share/man >> $(CONFIG)
	@echo "INCDIR	= " $(DESTDIR)$(PREFIX)/include >> $(CONFIG)
	@echo "BINDIR	= " $(DESTDIR)$(PREFIX)/bin >> $(CONFIG)
	@echo "LIBDIR	= " $(DESTDIR)$(PREFIX)/lib >> $(CONFIG)
	@echo "GAMEDIR	= " $(DESTDIR)$(PREFIX)/games >> $(CONFIG)
	@echo "DATADIR	= " $(DESTDIR)$(PREFIX)/share/wws >> $(CONFIG)
	@echo "ICONDIR	= " $(DESTDIR)$(PREFIX)/share/wws/icons >> $(CONFIG)
	@echo "FONTDIR	= " $(DESTDIR)$(PREFIX)/share/wws/fonts >> $(CONFIG)
	@echo "# run-time directories for server" >> $(CONFIG)
	@echo "DATADIR_RUN	= " $(PREFIX)/share/wws >> $(CONFIG)
	@echo "ICONDIR_RUN	= " $(PREFIX)/share/wws/icons >> $(CONFIG)
	@echo "FONTDIR_RUN	= " $(PREFIX)/share/wws/fonts >> $(CONFIG)

messages:
	@echo
	@echo "You're running a '"$(ARCH)"' system which is 'supported' by W, fine."
	@echo
	@echo "A file '.config' has been created for you in the main directory. This one will"
	@echo "be included by all the other Makefiles to customize to your setup. You should"
	@echo "check that compiling options, shell utilities and installation paths there are"
	@echo "suitable for your setup (normally they should, but better be sure than sorry)."
	@echo
	@echo "Makefile offers the standard 'install', 'clean' and 'veryclean' targets."
	@echo "There are also 'installfull', 'cleanfull' and 'verycleanfull' targets."
	@echo
	@echo "Now you can continue to build the default binaries by typing '$(MAKE)' or"
	@echo "(in Bourne shell) '$(MAKE) > errors 2>&1' if you want to check out"
	@echo "the compiler messages later."
	@echo

config: $(ARCH) pathversion messages

# --------- special configs -----------

linuxfb:
	$(COPY) configs/Linux-x86 $(CONFIG)
	@echo
	@echo "NOTE: for-x86 linux, you'll need also GPM library for accessing"
	@echo "the mouse.  Because of a GPM feature, W screen contents won't be"
	@echo "restored after VT-switch.  Either compile W with the REFRESH"
	@echo "option (in server/config.h, adds redraw option to W root menu)"
	@echo "or 'repaint' the screen with some window. ;-)"

# linux framebuffer conf
linuxfb-config: linuxfb messages

svgalib:
	$(COPY) configs/Linux-SVGAlib $(CONFIG)

# linux-svgalib config
svgalib-config: svgalib messages

linuxggi:
	$(COPY) configs/Linux-GGI $(CONFIG)
	@echo
	@echo "NOTE: for linux-GGI, you'll need also libGGI/libGII libraries"
	@echo "with an API compatible with this W version.  LibGGI will"
	@echo "allow you to run W (server) in addition to linux-fb also"
	@echo "with X, SVGAlib etc..."

# linux framebuffer conf
linuxggi-config: linuxggi messages

linuxsdl:
	$(COPY) configs/Linux-SDL $(CONFIG)
	@echo
	@echo "NOTE: LibSDL will allow you to run W (server) in X,"
	@echo "Linux framebuffer etc..."

# SDL configuration
linuxsdl-config: linuxsdl messages


# Default handler for unknown systems to provide a proper error message,
# in case any of the following system types don't overrule this.
.DEFAULT:
	@echo "If '$@' target is a platform, it doesn't seem to be supported."
	@echo
	@echo "In that case you could write up the configs/$@ configuration"
	@echo "file and Makefile entry for it and retry 'make config'.  When"
	@echo "you'll succeed, mail your changes to 'oak@welho.com'"
	@echo "(current maintainer)."
	@false

=== apps/Makefile ===
#
# makefile for W applications
#
# CHANGES:
# - separate crypt library is required for some platforms

include ../.config


CFLAGS	= -I../lib $(BASECFLAGS) $(CLIENTCFLAGS) -I..$(UTILCPP) \
   '-DDATADIR="$(DATADIR_RUN)"'  '-DICONDIR="$(ICONDIR_RUN)"'
LDFLAGS	= -L../lib $(CLIENTLDFLAGS)
LDLIBS	= $(CLIENTLIBS) -L..$(UTILLIB)
LIBDEP	= ../lib/$(WLIB)


SUBDIRS = wsaver

TARGETS = fontedit ring ringd wbiff pbmbitflip ppm24to8 ppm8to24 wbm wclock \
	 wchars wcpyrgt weyes wload wlaunch wsetbg wstatus wterm wkbd \
	 wgone wsaver/wsaver

#
# rules
#

all: $(TARGETS)

install: $(TARGETS) iconinstall
ifdef BINDIR
	$(INSTALLDIRS) $(BINDIR)
	for i in $(TARGETS) ; do \
		$(INSTALLBIN) $$i $(BINDIR) ; \
	done
endif

iconinstall: $(wildcard images/icons/*.p*)
ifdef ICONDIR
	$(INSTALLDIRS) $(ICONDIR)
	for i in $^; do $(INSTALL) -m 644 $$i $(ICONDIR); done
endif
	

clean:
	$(RM) *.o $(JUNK)
	for i in $(SUBDIRS) ; do \
		$(MAKE) -C $$i clean ; \
	done

veryclean: clean
	$(RM) $(TARGETS)

#
# more rules
#

fontedit: fontedit.o ../server/config.h
	$(CC) $< $(LDFLAGS) -o $@

ring: ring.o
	$(CC) $< $(LDFLAGS) $(LDLIBS) -o $@

ringd: ringd.o $(LIBDEP)
	$(CC) ringd.o $(LDFLAGS) $(LDLIBS) -o $@

wbiff: wbiff.o $(LIBDEP)
	$(CC) wbiff.o $(LDFLAGS) $(LDLIBS) -o $@

pbmbitflip: pbmbitflip.o $(LIBDEP)
	$(CC) pbmbitflip.o $(LDFLAGS) $(LDLIBS) -o $@

ppm24to8: ppm24to8.o $(LIBDEP)
	$(CC) ppm24to8.o $(LDFLAGS) $(LDLIBS) -o $@

ppm8to24: ppm8to24.o $(LIBDEP)
	$(CC) ppm8to24.o $(LDFLAGS) $(LDLIBS) -o $@

wbm: wbm.o $(LIBDEP)
	$(CC) wbm.o $(LDFLAGS) $(LDLIBS) -o $@

wchars: wchars.o $(LIBDEP)
	$(CC) wchars.o $(LDFLAGS) $(LDLIBS) -o $@

wclock: wclock.o $(LIBDEP)
	$(CC) wclock.o $(LDFLAGS) $(LDLIBS) -o $@

wcpyrgt: wcpyrgt.o $(LIBDEP)
	$(CC) wcpyrgt.o $(LDFLAGS) $(LDLIBS) -o $@

weyes: weyes.o $(LIBDEP)
	$(CC) weyes.o $(LDFLAGS) $(LDLIBS) -o $@

wgone: wgone.o $(LIBDEP)
	$(CC) wgone.o $(LDFLAGS) $(LDLIBS) $(CRYPTLIB) -o $@

wkbd: wkbd.o $(LIBDEP)
	$(CC) wkbd.o $(LDFLAGS) $(LDLIBS) -o $@

wload: wload.o $(LIBDEP)
	$(CC) wload.o $(LDFLAGS) $(LDLIBS) -o $@

wlaunch.o: basename.c

wlaunch: wlaunch.o $(LIBDEP)
	$(CC) wlaunch.o $(LDFLAGS) $(LDLIBS) -o $@

wsetbg: wsetbg.o $(LIBDEP)
	$(CC) wsetbg.o $(LDFLAGS) $(LDLIBS) -o $@

wstatus: wstatus.o $(LIBDEP)
	$(CC) wstatus.o $(LDFLAGS) $(LDLIBS) -o $@

wterm: wterm.o $(LIBDEP)
	$(CC) wterm.o $(LDFLAGS) $(LDLIBS) $(PORTLIB) -o $@

ifdef EXPORT_TERMCAP
wterm.o: wterm.c termtype.h
	$(CC) wterm.c $(CFLAGS) -DEXPORT_TERMCAP -c -o $@
endif

wsaver/wsaver: $(LIBDEP)
	$(MAKE) -C wsaver

=== benchmark/Makefile ===
#
# makefile for W benchmarks
#

include ../.config

CFLAGS	= -I../lib $(BASECFLAGS) $(CLIENTCFLAGS) $(MATHCFLAGS) -I..$(UTILCPP)
LDFLAGS	= -L../lib $(CLIENTLDFLAGS)
LDLIBS	= $(CLIENTLIBS)
LIBDEP	= ../lib/$(WLIB)


TARGETS = wperfmon wengine

#
# rules
#

all: $(TARGETS)

install: $(TARGETS)
ifdef BINDIR
	$(INSTALLDIRS) $(BINDIR)
	for i in $(TARGETS) ; do \
		$(INSTALLBIN) $$i $(BINDIR) ; \
	done
endif

clean:
	$(RM) *.o $(JUNK)

veryclean: clean
	$(RM) $(TARGETS)

#
# more rules
#

wengine: wengine.o $(LIBDEP)
	$(CC) $(LDFLAGS) wengine.o $(LDLIBS) $(MATHLIB) -o $@

wperfmon: wperfmon.o $(LIBDEP)
	$(CC) $(LDFLAGS) wperfmon.o $(LDLIBS) -L..$(UTILLIB) -o $@

=== demos/Makefile ===
#
# Makefile for (W library) demos
#

include ../.config


CFLAGS	= -I../lib $(BASECFLAGS) $(CLIENTCFLAGS)
LDFLAGS	= -L../lib $(CLIENTLDFLAGS)
LDLIBS	= $(CLIENTLIBS)
LIBDEP	= ../lib/$(WLIB)

# all possible targets
TARGETS_ALL = 3point boxtest gfxdemo filltest linetest pietest warp \
	 wbuttons wcolor wdim wfont wfontdemo wmouse wresize wscroll

# by default do only these, could be "TARGETS_DEFAULT = $(TARGETS_ALL)"
TARGETS_DEFAULT = warp wfont wfontdemo

#
# rules
#

default: $(TARGETS_DEFAULT)

all: $(TARGETS_ALL)


3point: 3point.o $(LIBDEP)
	$(CC) $(CFLAGS) $(LDFLAGS) 3point.o $(LDLIBS) -o $@

boxtest: boxtest.o $(LIBDEP)
	$(CC) $(CFLAGS) $(LDFLAGS) boxtest.o $(LDLIBS) -o $@

gfxdemo: gfxdemo.o $(LIBDEP)
	$(CC) $(CFLAGS) $(LDFLAGS) gfxdemo.o $(LDLIBS) -o $@

filltest: filltest.o $(LIBDEP)
	$(CC) $(CFLAGS) $(LDFLAGS) filltest.o $(LDLIBS) -o $@

linetest: linetest.o $(LIBDEP)
	$(CC) $(CFLAGS) $(LDFLAGS) linetest.o $(LDLIBS) -o $@

pietest: pietest.o $(LIBDEP)
	$(CC) $(CFLAGS) $(LDFLAGS) pietest.o $(LDLIBS) -o $@

warp: warp.o $(LIBDEP)
	$(CC) $(CFLAGS) $(LDFLAGS) warp.o $(LDLIBS) -o $@

wbuttons: wbuttons.o $(LIBDEP)
	$(CC) $(CFLAGS) $(LDFLAGS) wbuttons.o $(LDLIBS) -o $@

wcolor: wcolor.o $(LIBDEP)
	$(CC) $(CFLAGS) $(LDFLAGS) wcolor.o $(LDLIBS) -o $@

wdim: wdim.o $(LIBDEP)
	$(CC) $(CFLAGS) $(LDFLAGS) wdim.o $(LDLIBS) -o $@

wfont: wfont.o $(LIBDEP)
	$(CC) $(CFLAGS) $(LDFLAGS) wfont.o $(LDLIBS) -o $@

wfontdemo: wfontdemo.o $(LIBDEP)
	$(CC) $(CFLAGS) $(LDFLAGS) wfontdemo.o $(LDLIBS) -o $@

wmouse: wmouse.o $(LIBDEP)
	$(CC) $(CFLAGS) $(LDFLAGS) wmouse.o $(LDLIBS) -o $@

wresize: wresize.o $(LIBDEP)
	$(CC) $(CFLAGS) $(LDFLAGS) wresize.o $(LDLIBS) -o $@

wscroll: wscroll.o $(LIBDEP)
	$(CC) $(CFLAGS) $(LDFLAGS) wscroll.o $(LDLIBS) -o $@


install: $(TARGETS_DEFAULT)
ifdef BINDIR
	$(INSTALLDIRS) $(BINDIR)
	for i in $(TARGETS_DEFAULT) ; do \
		$(INSTALLBIN) $$i $(BINDIR) ; \
	done
endif


clean:
	$(RM) *.o $(JUNK)

veryclean: clean
	$(RM) $(TARGETS)

=== docs/Makefile ===
#
# makefile for W documentation installation
#

include ../.config

#
# rules
#

ifdef DOCDIR
install: textdocs htmldocs readmes
else
install:
	@echo "WARNING: DOCDIR isn't set, cannot install documentation"
endif

DOCS = BUGS CHANGES CHANGES.Eeros COPYRIGHTS FAQ FILES.doc GPL LGPL MIT \
  PORTING README.MacMiNT README.old TODO ../README ../RELEASE.notes

textdocs: $(DOCS)
	$(INSTALLDIRS) $(DOCDIR)
	for i in $^; do	$(INSTALL) -m 644 $$i $(DOCDIR); done


htmldocs: $(wildcard html/*.html)  $(wildcard html/*.png)
	$(INSTALLDIRS) $(DOCDIR)/html
	for i in $^; do	$(INSTALL) -m 644 $$i $(DOCDIR)/html; done


READMES = $(shell find .. -mindepth 2 -name 'README*'|grep -v /docs/)

readmes: $(READMES)
	$(INSTALLDIRS) $(DOCDIR)
	for i in $^; do	\
	basename=$${i##*/}; \
	dirname=$${i%/*}; \
	dirname=$${dirname##*/}; \
	$(INSTALL) -m 644 $$i $(DOCDIR)/$$basename.$$dirname; \
	done

=== fonts/Makefile ===
#
# makefile for W fonts and converters
#
# installs just fonts, not programs

include ../.config


CPPFLAGS = -I../lib
CFLAGS = $(BASECFLAGS)
LDFLAGS = -L../lib $(BASELDFLAGS)


TARGETS = bdf2wfnt fontconv

all: $(TARGETS)

bdf2wfnt: bdf2wfnt.o
	$(CC) $(LDFLAGS) $< -o $@

fontconv: fontconv.o
	$(CC) $(LDFLAGS) $< -o $@


FONTS = $(wildcard *.wfnt)

install:
	$(INSTALLDIRS) $(FONTDIR)
	for i in $(FONTS) ; do $(INSTALL) -m 644 $$i $(FONTDIR) ; done

clean:
	$(RM) *.o $(JUNK)

veryclean: clean
	$(RM) $(TARGETS)

=== games/Makefile ===
#
# makefile for W games
#

include ../.config


CFLAGS	= -I../lib $(BASECFLAGS) $(CLIENTCFLAGS)
LDFLAGS	= -L../lib $(CLIENTLDFLAGS)
LDLIBS	= $(CLIENTLIBS)
LIBDEP	= ../lib/$(WLIB)


SUBDIRS = wdragon wjewel wyrms

TARGETS = lsys wapfel wlife wmines wpuzzle wreversi wrobots wsolitaire \
	wdragon/wdragon wjewel/wjewel wyrms/wwyrms

#
# rules
#

all: $(TARGETS)

install: $(TARGETS)
ifdef GAMEDIR
	$(INSTALLDIRS) $(GAMEDIR)
	for i in $(TARGETS) ; do \
		$(INSTALLBIN) $$i $(GAMEDIR) ; \
	done
endif

clean:
	$(RM) *.o $(JUNK)
	for i in $(SUBDIRS) ; do \
		$(MAKE) -C $$i clean ; \
	done

veryclean: clean
	$(RM) *.o $(JUNK)
	for i in $(SUBDIRS) ; do \
		$(MAKE) -C $$i veryclean ; \
	done

#
# more rules & dependencies
#

lsys: lsys.o $(LIBDEP)
	$(CC) lsys.o $(LDFLAGS) $(LDLIBS) -o $@  

wapfel: wapfel.o $(LIBDEP)
	$(CC) wapfel.o $(LDFLAGS) $(LDLIBS) -o $@  

wlife: wlife.o $(LIBDEP)
	$(CC) wlife.o $(LDFLAGS) $(LDLIBS) -o $@  

wmines: wmines.o $(LIBDEP)
	$(CC) wmines.o $(LDFLAGS) $(LDLIBS) -o $@  

wpuzzle: wpuzzle.o $(LIBDEP)
	$(CC) wpuzzle.o $(LDFLAGS) $(LDLIBS) -o $@  

wreversi: wreversi.o $(LIBDEP)
	$(CC) wreversi.o $(LDFLAGS) $(LDLIBS) -o $@  

wrobots: wrobots.o $(LIBDEP)
	$(CC) wrobots.o $(LDFLAGS) $(LDLIBS) -o $@  

wsolitaire: wsolitaire.o $(LIBDEP)
	$(CC) wsolitaire.o $(LDFLAGS) $(LDLIBS) -o $@  

# larger games

wdragon/wdragon: $(LIBDEP)
	$(MAKE) -C wdragon

wjewel/wjewel: $(LIBDEP)
	$(MAKE) -C wjewel

wyrms/wwyrms: $(LIBDEP)
	$(MAKE) -C wyrms wwyrms

=== lib/Makefile ===
#
# Makefile for Wlib, the W library
#
# ++bsittler 2000-07-04:
# - now Wlib.h is automatically generated so _WMAJ, _WMIN and _WPL are correct
# ++eero 2009-08.30:
# - use proper library versioning for shared library

include ../.config

#
# targets, depending on the machine
#

CFLAGS = $(BASECFLAGS) $(CLIENTCFLAGS) -DTRACE

#
# some definitions
#

SRCS = $(wildcard *.c)
OBJS = $(patsubst %.c, %.o, $(SRCS))
SOBJS = $(patsubst %.c, %.O, $(SRCS))
BOBJS = $(patsubst %.c, %.ob, $(SRCS))
GOBJS = $(patsubst %.c, %.og, $(SRCS))

#
# rules
#

all: $(WLIB)

# Wlib.h header, built from Wlib_in.h
Wlib.h: Wlib_in.h ../Makefile
	@echo Generating $@ from $<
	@echo "/*" > $@
	@echo " * THIS FILE IS AUTOMATICALLY GENERATED; DO NOT EDIT IT!!!" >> $@
	@echo " * Instead, edit" $< "and make" $@ "to re-generate." >> $@
	@echo " */" >> $@
	@echo "" >> $@
	@echo "#define _WMAJ " $(WMAJ) >> $@
	@echo "#define _WMIN " $(WMIN) >> $@
	@echo "#define _WPL  " $(WPL)  >> $@
	@echo "" >> $@
	@cat $< >> $@

# versioned Linux shared library
libW.so.$(WMAJ).$(WMIN): Wlib.h $(SOBJS)
	$(CC) -shared -Wl,-soname,$@ $(SOBJS) -o $@

libW.so: libW.so.$(WMAJ).$(WMIN)
	$(LN) -sf $< $@

libW.a: Wlib.h $(OBJS)
	$(RM) $@
	$(AR) $@ $(OBJS)
ifdef RANLIB
	$(RANLIB) $@
endif

libWg.a: Wlib.h $(GOBJS)
	$(RM) $@
	$(AR) $@ $(GOBJS)
ifdef RANLIB
	$(RANLIB) $@
endif

blibW.a: Wlib.h $(BOBJS)
	$(RM) $@
	$(AR) $@ $(BOBJS)
ifdef RANLIB
	$(RANLIB) $@
endif

# some MiNT linkers use this name format
bW.olb: Wlib.h $(BOBJS)
	$(RM) $@
	$(AR) $@ $(BOBJS)
ifdef RANLIB
	$(RANLIB) $@
endif


.SUFFIXES: .O .ob .og

.c.O: Wlib.h
	$(CC) $(CPPFLAGS) $(CFLAGS) -fpic -c $< -o $@

.c.ob: Wlib.h
	$(CC) $(CPPFLAGS) $(CFLAGS) -c $< -o $@

.c.og: Wlib.h
	$(CC) $(CPPFLAGS) $(CFLAGS) -g -c $< -o $@

clean:
	$(RM) *.o *.O *.ob *.og $(JUNK)

veryclean: clean
	$(RM) *.a *.so *.a.* *.so.* *.olb Wlib.h

install: Wlib.h $(WLIB)
ifdef INCDIR
	$(INSTALLDIRS) $(INCDIR)
	$(INSTALL) -m 644 Wlib.h $(INCDIR)
endif
ifdef LIBDIR
	$(INSTALLDIRS) $(LIBDIR)
ifeq ($(WLIB),libW.so)
	# shared libraries are versioned
	$(INSTALL) -m 644 $(WLIB).$(WMAJ).$(WMIN) $(LIBDIR)
	cd $(LIBDIR); ln -s $(WLIB).$(WMAJ).$(WMIN) $(WLIB)
else
	$(INSTALL) -m 644 $(WLIB) $(LIBDIR)
endif
endif

=== man/Makefile ===
#
# Makefile for W manual pages
#

include ../.config

install:
ifdef MANDIR
	$(MAKE) -C man1 install
	$(MAKE) -C man3 install
	$(MAKE) -C man6 install
endif

clean:
	$(RM) cat1/*.1

veryclean: clean

=== scripts/Makefile ===
#
# makefile for W helper scripts
#
# Note: All READMEs are installed by docs/Makefile

include ../.config

#
# rules
#

install: docs scripts

scripts: startw wview wrootpic won xbm2w
ifdef BINDIR
	$(INSTALLDIRS) $(BINDIR)
	for i in $^; do $(INSTALL) -m 755 $$i $(BINDIR); done
endif

docs: colors.txt vt52.txt
ifdef DOCDIR
	$(INSTALLDIRS) $(DOCDIR)
	for i in $^; do	$(INSTALL) -m 644 $$i $(DOCDIR); done
endif

=== server/Makefile ===
#
# makefile for W server
#

include ../.config

CFLAGS	= $(BASECFLAGS) $(SERVERCFLAGS) -I..$(UTILCPP)
LDFLAGS	= -Lgraph $(SERVERLDFLAGS) -L..$(UTILLIB)
LDLIBS	= -lgraph $(SERVERLIBS)
TARGETS	= subdirs wserver

ifeq ($(WLIB),bW.olb)
# old style MiNT library names
DEPEND	= graph/graph.olb
else
DEPEND	= graph/libgraph.a
endif

#
# some definitions
#

WHDR   = config.h proto.h types.h
WLIB_H = ../lib/Wlib.h
SRCS   = $(wildcard *.c)

OBJS = $(patsubst %.c, %.o, $(SRCS))


#
# rules
#

all: subdirs wserver

subdirs: $(WHDR)
	$(MAKE) -C graph
ifdef UTILLIB
	$(MAKE) -C util
endif
ifeq ($(ARCH),MiNT)
ifdef MAC
	$(MAKE) -C macdevs
else
	$(MAKE) -C xconout2
endif
endif

wserver: $(OBJS) $(DEPEND)
	$(CC) $(LDFLAGS) $(OBJS) $(LDLIBS) -o $@

# symbol file for MiNT gdb
wserver.sym: $(OBJS) $(DEPEND)
	$(CC) -g $(LDFLAGS) $(OBJS) $(LDLIBS) $(SYM_LD) -o $@

#####

$(OBJS): $(WHDR)

types.h: $(WLIB_H)

$(WLIB_H):
	$(MAKE) -C $(WLIB_H)

font.o: font.c $(WHDR)
	$(CC) $(CPPFLAGS) $(CFLAGS)  '-DFONTDIR="$(FONTDIR_RUN)"' -c $< -o $@

main.o: main.c $(WHDR)
	$(CC) $(CPPFLAGS) $(CFLAGS)  '-DDATADIR="$(DATADIR_RUN)"' -c $< -o $@

loop.o: pakets.h $(WHDR)
window.o: window.h $(WHDR)
rect.o: rect.h $(WHDR)


#####

install: wserver
ifdef BINDIR
	$(INSTALLDIRS) $(BINDIR)
	$(INSTALLBIN) wserver $(BINDIR)
ifeq ($(ARCH),MiNT)
	$(MAKE) -C xconout2 install
endif
endif

clean:
	$(RM) *.o $(JUNK)
	$(MAKE) -C graph clean
	$(MAKE) -C util clean
	$(MAKE) -C xconout2 clean

veryclean:
	$(RM) wserver *.o $(JUNK)
	$(MAKE) -C graph veryclean
	$(MAKE) -C util veryclean
	$(MAKE) -C xconout2 veryclean

=== w2xlib/Makefile ===
#
# Makefile for W2Xlib, Wlib emulation on top of Xlib
#

NAME = libW2X.so

include ../.config

#
# targets, depending on the machine
#

CFLAGS = $(BASECFLAGS) $(CLIENTCFLAGS) -DTRACE

#
# some definitions
#

SRCS = $(wildcard *.c)
OBJS = $(patsubst %.c, %.o, $(SRCS))
SOBJS = $(patsubst %.c, %.O, $(SRCS))
BOBJS = $(patsubst %.c, %.ob, $(SRCS))
GOBJS = $(patsubst %.c, %.og, $(SRCS))

#
# rules
#

# have to run Make again so that patterns get right *after* links are generated
all: links
	@echo ; $(MAKE) -C ./ $(NAME)
#	@echo
#	@echo "Btw. if there are suspiciously few object files,"
#	@echo "run '$(MAKE) links' and then try '$(MAKE)' again."


# versioned Linux shared library
libW2X.so.$(WMAJ).$(WMIN): Wlib.h $(SOBJS)
	$(CC) -shared -Wl,-soname,$@ $(SOBJS) -o $@ -lX11

libW2X.so: libW2X.so.$(WMAJ).$(WMIN)
	$(LN) -sf $< $@

libW2X.a: Wlib.h $(OBJS)
	$(RM) $@
	$(AR) $@ $(OBJS)
ifdef RANLIB
	$(RANLIB) $@
endif

libW2Xg.a: Wlib.h $(GOBJS)
	$(RM) $@
	$(AR) $@ $(GOBJS)
ifdef RANLIB
	$(RANLIB) $@
endif

blibW2X.a: Wlib.h $(BOBJS)
	$(RM) $@
	$(AR) $@ $(BOBJS)
ifdef RANLIB
	$(RANLIB) $@
endif

# some MiNT linkers use this name format
bW2X.olb: Wlib.h $(BOBJS)
	$(RM) $@
	$(AR) $@ $(BOBJS)
ifdef RANLIB
	$(RANLIB) $@
endif


# mouse.c and winutil.c not implemented
# socket.c and vhline.c not needed
DONT_USE = mouse.c socket.c vhline.c winutil.c

# make sure needed links exist
links:
	@cd ../lib ; \
	for i in *.[ch] ; do \
		if [ ! -f ../w2xlib/$$i ] ; then \
			ln -s ../lib/$$i ../w2xlib/$$i ; \
		fi ; \
	done ; \
	cd ../w2xlib ; \
	for i in $(DONT_USE); do \
		if [ -L $$i ] ; then \
			rm $$i ; \
		fi ; \
	done
	@true


.SUFFIXES: .O .ob .og

.c.O: Wlib.h
	$(CC) $(CPPFLAGS) $(CFLAGS) -fpic -c $< -o $@

.c.ob: Wlib.h
	$(CC) $(CPPFLAGS) $(BASECFLAGS) -mbaserel -c $< -o $@

.c.og: Wlib.h
	$(CC) $(CPPFLAGS) $(CFLAGS) -g -c $< -o $@


Wlib.h: ../lib/Wlib.h

../lib/Wlib.h:
	$(MAKE) -C ../lib Wlib.h
	ln -sf $@ .


clean:
	$(RM) *.o *.O *.ob *.og $(JUNK)

veryclean: clean
	$(RM) *.a *.so *.a.* *.so.* *.olb

install: Wlib.h $(NAME)
ifdef INCDIR
	$(INSTALLDIRS) $(INCDIR)
	$(INSTALL) -m 644 Wlib.h $(INCDIR)
endif
ifdef LIBDIR
	$(INSTALLDIRS) $(LIBDIR)
ifeq ($(NAME),libW2X.so)
	# shared libraries are versioned
	$(INSTALL) -m 644 $(NAME).$(WMAJ).$(WMIN) $(LIBDIR)
	cd $(LIBDIR); ln -s $(NAME).$(WMAJ).$(WMIN) $(NAME)
else
	$(INSTALL) -m 644 $(NAME) $(LIBDIR)
endif
endif

=== debian/changelog ===
wws (1.4.5) unstable; urgency=low

  * First properly Debian packaged W Window Wystem version.
  * Updated the W-Lua interpreter and Lua bindings to work with Lua v5.1.
  * Added versioning to all the shared libraries (libW, libWt, libW2X).
  * Install also scripts, wlaunch icons, some demos and documentation.
  * Updated Wterm and Wvt to work with Unix98 PTYs.
  * Fixed GCC 4.x compilation issues.

 -- Eero Tamminen <eerott@gmail.com>  Sun, 2 Sep 2009 22:33:08 +0300

=== debian/control ===
# print package list:
# awk '/Package/{printf($2)}/Description/{print}' control|sed 's/Description//'
Source: wws
Section: utils
Priority: optional
Maintainer: Eero Tamminen <eerott@gmail.com>
# W server uses 'libSDL', libw2x library uses 'libX11',
# Wlua interpreter uses 'tolua', console games use 'libncurses',
# Wetscape uses 'libjpeg', 'tic' for terminfo entry creation is in ncurses-bin
Build-Depends: debhelper (>= 4), libsdl1.2-dev, libx11-dev, libtolua-dev, libjpeg62-dev, libncurses5-dev, ncurses-bin
Standards-Version: 3.7.2

Package: wws-base
Architecture: any
Depends: ${shlibs:Depends}
Recommends: wws
# includes things used directly by wserver or wrc
Description: The W Window System server and basic applications
 The W Window System server, basic applications (terminal etc) and fonts.
 Server supports natively 1, 2, 4 and 8-bit graphics drivers.  For testing
 it can be used also on X11 desktop in any bitdepth with the help of libSDL.

Package: wws-base-dbg
Architecture: any
Priority: extra
Depends: wws-base (=${binary:Version})
Description: Debug package for wws-base
 Debug symbols for the W Window System server and basic applications.

Package: libw1.4
Architecture: any
Depends: ${shlibs:Depends}
Suggests: libwt0.9, wws-dev
Description: The W Window System client library
 Wlib, W Window System client library.

Package: libw1.4-dbg
Architecture: any
Priority: extra
Depends: libw1.4 (=${binary:Version})
Description: Debug package for libw1.4
 Debug symbols for the W Window System client library.

Package: libwt0.9
Architecture: any
Depends: ${shlibs:Depends}
Description: The W Window System GUI toolkit library
 Wt, W Window System GUI toolkit library.

Package: libwt0.9-dbg
Architecture: any
Priority: extra
Depends: libwt0.9 (=${binary:Version})
Description: Debug package for libwt0.9
 Debug symbols for the W Window System GUI toolkit library.

Package: libw2x1.4
Architecture: any
Depends: ${shlibs:Depends}
Suggests: wws-dev
Description: The Wlib-on-X emulation library
 Replacement for the Wlib library that allows running W window system
 applications directly on the X window system.

Package: libw2x1.4-dbg
Architecture: any
Priority: extra
Depends: libw2x1.4 (=${binary:Version})
Description: Debug package for libw2x1.4
 Debug symbols for the Wlib-on-X emulation library.

Package: wws-dev
Section: libdevel
Architecture: all
Depends: libw1.4 (=${binary:Version}), libw2x1.4 (=${binary:Version}), libwt0.9 (=${binary:Version})
Suggests: wws
Description: The development files for the W Window System libraries
 Headers and manual pages for the Wlib client libraries and Wt GUI toolkit.

Package: wws-apps
Architecture: any
Depends: ${shlibs:Depends}
Recommends: netpbm, wws
Description: More advanced W Window System applications
 Several applications (including HTML v1 browser + color terminal
 emulator), their manual pages and icons for wlaunch.

Package: wws-apps-dbg
Architecture: any
Priority: extra
Depends: wws-apps (=${binary:Version})
Description: Debug package for wws-apps
 Debug symbols for the more advanced W Window System applications.

Package: console-board-games
Architecture: any
Depends: ${shlibs:Depends}
suggests: wws-games
Description: Some networked, console based board games + daemons
 Networked curses user interfaces to Reversi, Gomoku, Pente/Renju
 and Go board games.  Computer daemons to Reversi, Pente and Go.

Package: console-board-games-dbg
Architecture: any
Priority: extra
Depends: console-board-games (=${binary:Version})
Description: Debug package for console-board-games
 Debug symbols for the networked console board games.

Package: wws-games
Architecture: any
# some manual pages are shared with the console games
Depends: ${shlibs:Depends}, console-board-games
Recommends: netpbm, wws
Description: The W Window System games
 Many games (including also several networked board games),
 toys/demos and their manual pages.

Package: wws-games-dbg
Architecture: any
Priority: extra
Depends: wws-games (=${binary:Version})
Description: Debug package for wws-games
 Debug symbols for the W Window System games.

Package: wlua
Architecture: any
Depends: ${shlibs:Depends}
Recommends: wws
Description: A Lua interpreter with W Window System support
 Wlua is a version of the Lua (a small embedded language) interpreter
 which provides Lua APIs for (a subset of) the W window system libraries
 functionality.

Package: wlua-dbg
Architecture: any
Priority: extra
Depends: wlua (=${binary:Version})
Description: Debug package for wlua
 Debug symbols for the W Lua interpreter.

Package: wws
Architecture: all
# netpbm is needed by the scripts
Depends: wws-base, wws-apps, wlua, wws-games, netpbm, libjpeg-progs
Description: Metapackage for the W window system with scripts and docs
 Metapackage with dependencies to the non-development W window system
 packages.  Includes also some helper scripts and all the W Window System
 documentation (release notes, porting instructions, READMEs for everything,
 design documentation...).

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# Eero:
# use: dpkg-buildpackage -uc -us -ICVS

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

CFLAGS = -Wall -g
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

# configuration is needed to do anything with WWS
configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.
	$(MAKE) DESTDIR=$(CURDIR)/debian/tmp config

	touch configure-stamp


build: build-stamp

build-stamp: configure-stamp 
	dh_testdir

	# Make W window system
	$(MAKE) full

	touch $@

# .config is needed for cleaning
clean: configure-stamp
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp

	# Add here commands to clean up after the build process.
	$(MAKE) verycleanfull

	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs

	# Add here commands to install the package into debian/wws.
	$(MAKE) installfull
	TERMINFO=$(CURDIR)/debian/tmp/usr/share/terminfo tic wterm.terminfo


# Build architecture-independent files here.
binary-indep: build install
# TODO: "wws" package should actually be constructed here...

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_install --sourcedir=debian/tmp
	dh_installman
	dh_link
	dh_strip --dbg-package=wws-server --dbg-package=libwws1.4 --dbg-package=libw2x1.4 --dbg-package=wws-apps --dbg-package=console-board-games --dbg-package=wws-games --dbg-package=wlua
	dh_compress
	dh_fixperms
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure
